//+------------------------------------------------------------------+
//|                                                   volum+para.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern double    shag_parab=0.3;
extern double    max_parab=0.2;
extern int       glubina=3;    //  
extern int       prof=100;
extern int       tral=500;

datetime Newtime;
bool BuyOp=false, SellOp=false;
int tik;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   if (Newtime!=iTime(Symbol(),0,0))  //    
      { 
      Newtime=iTime(Symbol(),0,0);
      if (OrdersTotal()==0)
         {
         //*******
         double chena_4=/*NormalizeDouble((iHigh(Symbol(),0,4)),Digits);*/NormalizeDouble((((iHigh(Symbol(),0,4)+iLow(Symbol(),0,4)+iOpen(Symbol(),0,4)+iClose(Symbol(),0,4))/4)),Digits);
         double chena_3=/*NormalizeDouble((iHigh(Symbol(),0,3)),Digits);*/NormalizeDouble((((iHigh(Symbol(),0,3)+iLow(Symbol(),0,3)+iOpen(Symbol(),0,3)+iClose(Symbol(),0,3))/4)),Digits);
         double chena_2=/*NormalizeDouble((iHigh(Symbol(),0,2)),Digits);*/NormalizeDouble((((iHigh(Symbol(),0,2)+iLow(Symbol(),0,2)+iOpen(Symbol(),0,2)+iClose(Symbol(),0,2))/4)),Digits);
         double chena_1=/*NormalizeDouble((iHigh(Symbol(),0,1)),Digits);*/NormalizeDouble((((iHigh(Symbol(),0,1)+iLow(Symbol(),0,1)+iOpen(Symbol(),0,1)+iClose(Symbol(),0,1))/4)),Digits);
         //*******
         int volum_4=iVolume(Symbol(),0,4);
         int volum_3=iVolume(Symbol(),0,3);
         int volum_2=iVolume(Symbol(),0,2);
         int volum_1=iVolume(Symbol(),0,1);
         //*******
         double parab_4=iSAR(Symbol(),0,shag_parab,max_parab,4);
         double parab_3=iSAR(Symbol(),0,shag_parab,max_parab,3);
         double parab_2=iSAR(Symbol(),0,shag_parab,max_parab,2);
         double parab_1=iSAR(Symbol(),0,shag_parab,max_parab,1);
         //*******
         if(chena_4<chena_3 && chena_3<chena_2 && chena_2<chena_1 && volum_3<volum_2 
            && volum_2<volum_1 && volum_4<volum_3 && parab_4<parab_3 && parab_3<parab_2 && parab_2<parab_1) BuyOp=true;
         if(chena_4>chena_3 && chena_3>chena_2 && chena_2>chena_1 && volum_3<volum_2 
            && volum_2<volum_1 && volum_4<volum_3 && parab_4>parab_3 && parab_3>parab_2 && parab_2>parab_1) SellOp=true;
         
         //*******
         if (BuyOp==true)
            {
            double parab_b_0=iSAR(Symbol(),0,shag_parab,max_parab,0);
            if (parab_b_0>Open[0]) return;
            else tik=OrderSend(Symbol(),OP_BUY,0.1,Ask,3,Ask-Point*tral,Bid+Point*prof,"      "+Open[0],111111,0,Green);
            BuyOp=false;
            }
         if (SellOp==true)
            {
            double parab_s_0=iSAR(Symbol(),0,shag_parab,max_parab,0);
            if (parab_s_0<Open[0]) return;
            else tik=OrderSend(Symbol(),OP_SELL,0.1,Bid,3,Bid+Point*tral,Ask-Point*prof,"      "+Open[0],222222,0,Yellow);
            SellOp=false;
            }
         }
      if (OrdersTotal()!=0)
         {
         OrderSelect(tik,SELECT_BY_TICKET,MODE_TRADES);
         //*******
         if(OrderType()==OP_BUY)
            {
            double parab_st_0=iSAR(Symbol(),0,shag_parab,max_parab,0);
            if (parab_st_0>High[0]) OrderClose(tik,0.1,Bid,3,Red);
            if (OrderStopLoss()!=parab_st_0) OrderModify(tik,OrderOpenPrice(),parab_st_0,OrderTakeProfit(),0,Blue);
            }
         //*******
         if(OrderType()==OP_SELL)
            {
            double parab_sp_0=iSAR(Symbol(),0,shag_parab,max_parab,0);
            if (parab_sp_0<Low[0]) OrderClose(tik,0.1,Ask,3,Red);
            /*double tralll=Traling();*/
            if (OrderStopLoss()!=parab_sp_0) OrderModify(tik,OrderOpenPrice(),parab_sp_0,OrderTakeProfit(),0,Blue);
            }
         }
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double Traling ()
   {
   OrderSelect(tik,SELECT_BY_TICKET,MODE_TRADES);
   
   double x_0=iHigh(Symbol(),0,1);
   double x_1=OrderStopLoss();
   double x_2=iOpen(Symbol(),0,0);
   double x_3=OrderStopLoss()-(OrderStopLoss()*((x_1-x_2)-(x_1-x_0))/(x_1-x_2));
   return (x_3);
   }